y³OJ Project 是一个开放源代码项目，所有代码均在开源在 Github 上以 [AGPL-3.0-only](https://spdx.org/licenses/AGPL-3.0-only.html) 协议开源。

## 如何开发调试

本项目仍在起步阶段，相关工具和单元测试并不完善。

### 网页端

```bash
python run-dev.py          # dev server
```

启动 Flask Dev Server。

### 前端

```bash
python build-frontend.py --watch          # watch mode
```

启动前端构建脚本的 watch 模式，将使用系统 API 监听文件更改并自动构建。

如果遇到期望结果不一致，可以考虑打开 `--force` 选项，每次构建时将会重新打包所有文件。

### 评测端

```bash
npm run judge-test           # unit test
npm run judge-start          # start server
```

请确保修改后的评测端能通过单元测试，有需要的话，也可以参照 `y3oj-judger/test/main.js` 的格式自行添加测试点。

网页端和评测端的通信基于 websocket 协议。需要注意的是，重启服务器后，网站端需要重新建立 websocket 链接。

## 如何贡献代码

你可以在 Github 上 fork 我们的项目，并提交你的修改。之后，可以提交一个 Pull Request，我们会进行代码审查并考虑合并。

如果你只需要修改源码的一小部分（如纠正文档中的错别字），也可以直接在 github.com 上点击编辑按钮进行修改。

## 如何参与项目的开发和维护

你是否想参与项目的后续开发规划？是否想参与项目的维护工作？  

如果你是本项目的 Contributor（即至少提交过一次任意内容的 Pull Request），并愿意参加项目的相关工作，可以联系 [@memset0](https://github.com/memset0) 申请项目的管理权限。

欢迎成为我们的一员！
